
CursorX    equ 8320h		;Userram 83xxh - Xpos

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	Header

	Padding Off				;Stop the assembler adding zeros
	ORG  6000h				;Our program starts at 6000h
	
	WORD 0AA01h				;header
	Word 0
	Word 0
	WORD ProgramA			;Pointer to 1st program
	Word 0
	Word 0
ProgramA:   WORD 0			;1st entry 0=only one program
	WORD ProgramStart		;Start of Program
	BYTE 15					;Text Length
	BYTE "LEARNASM.NET   "	;Text Message
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	Program Start

		
ProgramStart:
	limi 0         ;disable interrupts
    lwpi 83C0h     ;set default workspace for registers to 
							;Ram at 83C0h

		
;Select Write address of first Character	
	li r0,0040h			;4000 byte swapped
				;Write 40 - 0020 - Vram for text chars
						
	movb r0,@8C02h;L	8C02h=Control Port
	swpb r0
	movb r0,@8C02h;H
	
	clr r0				;Zero Cursor Xpos
	movb r0,@CursorX	;Xpos
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			
	li r1,StrHelloWorld	;ascii string address
	bl @PrintString		;255 terminated string
	
	bl @NewLine			;Move Down a Line
	
	li r1,StrHelloWorld	;ascii string address
	bl @PrintString		;255 terminated string
	
	jmp $				;InfLoop
	
StrHelloWorld:			;255 terminated String
    byte "Hello World!"  
    byte 255
	align 2				;Even byte align
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Print Char R0

PrintChar:
	ci r0,06000h		;compare to 96 (no lowerchase chars)
	jlt PrintCharOk		;<96 then jump
	
	ai r0,0E000h 		;R0=R0-32 (Covert lowercase to upper)
PrintCharOk:
	movb r0,@8C00h		;DataPort - put next char on screen
	
	movb @CursorX,r0	;Load Cursor X
	ai r0,00100h		;Inc 1 char
	movb r0,@CursorX	;Save back
		
	b *r11				;Return
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Print 255 terminated string in *r1	
	
PrintString:			
	mov r11,r10			;Back up Return address
PrintStringAgain:
		movb *r1+,r0	;Read a Byte
		ci r0,0FF00h	;Is byte 255?
		jeq PrintStringDone
		bl @PrintChar	;Print the Character!
		jmp PrintStringAgain
PrintStringDone:
	b *R10				;Return		

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Keep printing spaces until we reach end of line	
	
NewLine:
	movb @CursorX,r0	;Get Xpos
	clr r1				;Space
NewLineb:
	movb r1,@8C00h		;DataPort - Put Char on screen
	ai r0,0100h
	andi r0,1F00h		;Keep filling until end of line
	jne NewLineb		;Inc Xpos
	movb r0,@CursorX    ;Save New XPos
	b *r11				;Return
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;