	include "\srcAll\v1_Header.asm"

	bl @ScrInit			;Initialize Screen
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
InfLoop:
	bl @Cls

	;R12=CRU address
	
;Read Whole Keyboard 	
	li R2,0000h       	;Column 0 of keyboard
NextKeyLine:
	li R12,0024h      	;CRU address of Keyboard Column Select
	ldcr R2,3           ;Select Column (Write 3 bits to CR)
    li R12,0006h      	;CRU address of the keyboard rows
	
	clr r4
	stcr r4,8			;Store 8 bits of CR into R4
	
	blwp @MonitorFlagsR4;Monitor Dump
	
	ai r2,0100h			;Next Column o Keyboard
	ci r2,0800h			;Last Columnn?
	jne NextKeyLine		;No? then repeat 
	
;Read a single key
	li R2,0600h       	;Column 6 of keyboard (Joy1)
	li R12,0024h      	;CRU address of Keyboard Column Select
	ldcr R2,3           ;Select it (Write 3 bits to CR)
    li R12,0006h      	;CRU address of the keyboard rows
	
	tb 4			;Test Bit 0=Fire 1=Left 2=Right 3=Down 4=Up
	jeq BZero
	
BOne:	
	li r0,'! '
	bl @PrintChar
	jmp InfLoop        	;Infinite Loop	
BZero:
	li r0,'- '
	bl @PrintChar
	jmp InfLoop        	;Infinite Loop
	
Cls:
	mov r11,r10				;Back up Return address	
		li r0,0000h			;Write 0000 - Vram for text chars
		bl @VDP_SetWriteAddress

		clr r0				;Zero Xpos
		movb r0,@CursorX	;Xpos	
	B *r10					;Return
	
	
MonitorFlagsR4:	
	word wspMonitor
	word DoMonitorBitsR4
	
DoMonitorBitsR4:
		mov r13,r6
		ai r6,4*2	
		mov *r6,r4		;Get R4
		
		mov r4,r2		;Get R4
		li r1,0400h
		bl @ShowReg
		
		li r1,8
FlagAgainB:
		li r0,'1 '
		sla r4,1
		joc FlagOnB
		li r0,'0 '
FlagOnB:
		bl @PrintChar
		
		dec r1
		jne FlagAgainB
		bl @NewLine
	RTWP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	include "\SrcAll\monitor.asm"
	include "\SrcAll\functions.asm"

	