		Padding Off
        ORG  6000h
		
		WORD 0AA01h			;header
		Word 0
		Word 0
        WORD  PROG1				;Pointer to 1st program
        Word 0
		Word 0
PROG1   WORD  0				;1st entry 0=only
        WORD  TiStart			;Start Of Program
        BYTE  15			;Text Length
		BYTE "LEARNASM.NET   "	;Text Message
		

WRKSP   EQU     8300h

VDPWD   EQU     8C00h           ;* VDP RAM write data
VDPWA   EQU     8C02h           ;* VDP RAM read/write address
VWTR 	EQU 	2030h

TiStart
		

	limi 0               ;disable interrupts
    lwpi 8300h           ;set default workspace
	
	
	li r1,VDPInit		;Set up graphics mode
	li r2,VDPInit_End-VDPInit
VDPAgain:		
	movb *r1+,@8C02h	;VDP Control port
	dec r2
	jne VDPAgain
	

;Bitmap Data address (8 bytes per tile)
	li r0,0000h+(128*8)	
	bl @VDP_SetWriteAddress
	
	li R1,TestSprite
	li R2,(TestSprite_end-TestSprite)	
	bl @otir			;Transfer Bitmap Data
	
	
;Color Data address (8 bytes per tile)
	LI R0,2000h+(128*8)
	bl @VDP_SetWriteAddress
	
	li R1,TestSpritePalette
	li R2,(TestSpritePalette_end-TestSpritePalette)
	bl @otir			;Transfer Colors
		
;Show Smiley
	li r1,1	;x
	li r2,2	;y
	bl @GetVDPScreenPos
	li r7,08000h		;80h=Tile 128
	movb r7,@VDPWD
	
	jmp $				;InfLoop

	
GetVDPScreenPos:		;(R1,R2)=X,Y
	mov r2,r0
	SLA R0,5
	a r1,r0
	ai r0,1800h
VDP_SetWriteAddress:		
	ori r0,4000h		;Bit 6=Write
	swpb r0
	movb r0,@8C02h		;L	VDP Control Port
	swpb r0
	movb r0,@8C02h		;H
	B *r11				;RETURN
	
	
otir:					;Transfer r2 bytes of data to VRAM
	MOVB *r1+,@8C00h 	;VDP Data port
	dec r2
	jne otir
	B *r11				;RETURN


	
	;Need padding off - or lines will be WORD Aligned
testsprite:				;1 bit per pixel smiley
	BYTE 00111100b
	byte 01111110b	
	BYTE 11011011b
	byte 11111111b	
	BYTE 11111111b
	byte 11011011b	
	BYTE 01100110b
	byte 00111100b	
TestSprite_end:

TestSpritePalette:
	;   Nibbles=FB 	Fore,Back	
	BYTE 0A0h,0A0h,0BCh,0BCh,0BCh,0BCh,0ACh,0A0h	
	;A=Dk Yellow B=Yellow C=Green 
	;BYTE 60h,60h,60h,60h,60h,60h,60h,60h ;All Red
TestSpritePalette_end:

VDPInit:
	BYTE 00000010b,128+0	;mode register #0
	BYTE 01100000b,128+1	;mode register #1
	BYTE 00000110b,128+2	;Pattern table name
	BYTE 10011111b,128+3	;colour table (LOW)
	BYTE 00000000b,128+4	;pattern generator table
	BYTE 00110110b,128+5	;sprite attribute table (LOW)
	BYTE 00000111b,128+6	;sprite pattern generator table
	BYTE 11110000b,128+7	;border colour/character colour at text mode
VDPInit_End:
	