;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	Header

	Padding Off				;Stop the assembler adding zeros
	ORG  6000h				;Our program starts at 6000h
	
	WORD 0AA01h				;header
	Word 0
	Word 0
	WORD ProgramA			;Pointer to 1st program
	Word 0
	Word 0
ProgramA:   WORD 0			;1st entry 0=only one program
	WORD ProgramStart		;Start of Program
	BYTE 15					;Text Length
	BYTE "LEARNASM.NET   "	;Text Message
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	Program Start

		

ProgramStart:
	limi 0               ;disable interrupts
    lwpi 8300h           ;set default workspace
	
; set VDP RAM start address (low and high byte)
		

	li r1,VDPInit		;Set up graphics mode
	li r2,VDPInit_End-VDPInit
VDPAgain:		
	movb *r1+,@8C02h	;VDP Control port
	dec r2
	jne VDPAgain
	

;Bitmap Data address (8 bytes per tile)
	li r0,0000h+(128*8)	
	li r1,TestSprite
	li r2,(TestSprite_end-TestSprite)	
	bl @otir			;Transfer Bitmap Data
	
;Color Data address (8 bytes per tile)
	LI r0,2000h+(128*8)
	li r1,TestSpritePalette
	li r2,(TestSpritePalette_end-TestSpritePalette)
	bl @otir			;Transfer Colors
	
;Draw the Chibiko character	
	li r3,1			;x
	li r4,2			;y
	li r5,6 		;w
	li r6,6 		;h
	li r7,128*256 			;Tilenum
	
	;(r3,r4) =XY (r5,r6)=WH ;R7=Tile
	bl @FillAreaWithTiles
		
	jmp $					;InfLoop
		
		
;(r3,r4) =XY (r5,r6)=WH ;R7=Tile		
FillAreaWithTiles:		
	mov r11,r10
FillAreaWithTiles_Yagain:
		mov r3,r1
		mov r4,r2
		bl @GetVDPScreenPos
		mov r5,r1
FillAreaWithTiles_Xagain:
		movb r7,@8C00h		;VDP Data port
		ai r7,0100h			;Next Tile
		dec r1
		jne FillAreaWithTiles_Xagain
		inc r4
		dec r6
		jne FillAreaWithTiles_Yagain
	b *R10					;Return

		
	
GetVDPScreenPos:		;(R1,R2)=X,Y
	mov r2,r0
	SLA R0,5			;YPos *32
	a r1,r0				;+Xpos
	ai r0,1800h			;Tilemap Base
	
VDP_SetWriteAddress:		
	ori r0,4000h		;Bit 6=Write
	swpb r0
	movb r0,@8C02h		;L	VDP Control Port
	swpb r0
	movb r0,@8C02h		;H
	B *r11				;RETURN
	
;Transfer r2 bytes of data from R1 to VRAM address R0
otir:	
	mov r11,r10		
		bl @VDP_SetWriteAddress
otir2:
		MOVB *r1+,@8C00h 	;VDP Data port
		dec r2
		jne otir2
	b *R10					;Return



	
	
testsprite:		
	binclude "\ResALL\Sprites\RawMSX1.RAW"
TestSprite_end:	

TestSpritePalette:	;   FB 		=Fore		Back	
;Line 1 (8 lines, 6 Tiles per strip)
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
;Line 2	
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
;Line 3	
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
;Line 4
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
	BYTE 90h,90h,90h,90h,90h,90h,90h,90h		;Light Red
;Line 5
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
	BYTE 80h,80h,80h,80h,80h,80h,80h,80h		;Red
;Line 6	
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Dark red
TestSpritePalette_end:

;Screen Init Data
VDPInit:
	BYTE 00000010b,128+0	;mode register #0
	BYTE 01100000b,128+1	;mode register #1
	BYTE 00000110b,128+2	;Pattern table name
	BYTE 10011111b,128+3	;colour table (LOW)
	BYTE 00000000b,128+4	;pattern generator table
	BYTE 00110110b,128+5	;sprite attribute table (LOW)
	BYTE 00000111b,128+6	;sprite pattern generator table
	BYTE 11110000b,128+7	;border colour/character colour at text mode
VDPInit_End:
	