		Padding Off
        ORG  6000h
		
		WORD 0AA01h			;header
		Word 0
		Word 0
        WORD  PROG1				;Pointer to 1st program
        Word 0
		Word 0
PROG1   WORD  0				;1st entry 0=only
        WORD  TiStart			;Start Of Program
        BYTE  15			;Text Length
		BYTE "LEARNASM.NET   "	;Text Message
		

wspDefault equ 83C0h

CursorX equ 	83F0h

PlayerX equ 	83F1h
PlayerY equ 	83F2h
PlayerX2 equ 	83F3h
PlayerY2 equ 	83F4h

VDP_Data   EQU     8C00h           ;* VDP RAM write data
VDP_Ctrl   EQU     8C02h           ;* VDP RAM read/write address

TiStart
		

	LIMI    0              ;Disable Interrupts
    LWPI    wspDefault     ;Load Workspace Pointer

	

	li r0,0300h
	movb r0,@PlayerX		;Xpos
	movb r0,@PlayerY		;Ypos
	
	
	li R1,VDPInit				;Screen Init Data
	li R2,VDPInit_End-VDPInit	;Bytecount
VDPAgain:		
	MOVB *R1+,@VDP_Ctrl		;Send to VDP
	dec r2
	jne VDPAgain			;Repeate until Bytes is don e
	
	LI R0,0000h+(128*8)		;Tile 128
	bl @VDP_SetWriteAddress
	
	li R1,TestSprite		;Source Data
	li R2,(TestSprite_end-TestSprite)
	bl @otir
	
	LI R0,2000h+(128*8)		;Color for Tile 128
	bl @VDP_SetWriteAddress
	
	li R1,TestSpritePalette	;Source Data
	li R2,(TestSpritePalette_end-TestSpritePalette)
	bl @otir
InfLoop:		

	movb @PlayerX,@PlayerX2	;Back up blayer pos
	movb @PlayerY,@PlayerY2
	
	
	bl @ShowSprite		;Draw Smiley
	
	li r2,2000h			;Pause
Delay:		
	dec r2
	jne Delay
	
	bl @ClearSprite		;Remove Smiley
	
	li r10,0100h		;Byte=1
	
	LI R12,0024h     	;Point CR reg (R12) to Keyboard Matrix 0024h
	LI R1,0600h       	;Line 6 - Joy 1
	LDCR R1,3           ;Select 
	LI R12,0006h      	;CRU address of the keyboard rows 
	
	tb 1				;Test Bit 1 (Left)
	jeq NoLeft
	sb r10,@PlayerX		;Decrease byte by 1
NoLeft:
	tb 2				;Test Bit 2 (Right)
	jeq NoRight
	ab r10,@PlayerX		;Increase byte by 1
NoRight:
	tb 3				;Test Bit 3 (Down)
	jeq NoDown
	ab r10,@PlayerY		;Increase byte by 1
NoDown:
	tb 4				;Test Bit 4 (Up)
	jeq NoUp
	sb r10,@PlayerY		;Decreace byte by 1
NoUp:
	movb @PlayerX,r0	;Xpos>=32?
	ci r0,02000h
	jhe PlayerReset		
	
	movb @PlayerY,r0	;Xpos>=24?
	ci r0,01800h
	jhe PlayerReset		
	
	JMP InfLoop
	
PlayerReset:			;Reset Player position
	movb @PlayerX2,@PlayerX
	movb @PlayerY2,@PlayerY
	JMP InfLoop
	
ClearSprite:	
	li r7,08100h		;Tile 129 (Clear)	
	b @ShowBoth
ShowSprite:				;Show tile R7 at XY pos (R1,R2)
	li r7,08000h		;Tile 128 (Smile)
ShowBoth:	
	mov r11,r10
		movb @PlayerX,r1	
		movb @PlayerY,r2	
		bl @GetVDPScreenPos
		movb r7,@VDP_Data
	B *R10			;RETURN			
	
GetVDPScreenPos:	;(R1,R2)=X,Y
		
	andi r2,0FF00h	;Xpos Byte to Word
	swpb r2
	
	andi r1,0FF00h	;Ypos Byte to word
	swpb r1

	mov r2,r0		;Ypos*32
	SLA R0,5
	
	a r1,r0
	ai r0,1800h		;Tilemap base 
VDP_SetWriteAddress:		
	ori r0,4000h		;Bit 6=Write
	SWPB    R0
	MOVB    R0,@VDP_Ctrl	;H
	SWPB    R0
	MOVB    R0,@VDP_Ctrl	;L
	B *R11			;RETURN

otir:	
	MOVB *R1+,@VDP_Data
	dec r2
	jne otir
	B *R11			;RETURN


	
	
testsprite:				;1 bit per pixel smiley
	BYTE 00111100b
	byte 01111110b	
	BYTE 11011011b
	byte 11111111b	
	BYTE 11111111b
	byte 11011011b	
	BYTE 01100110b
	byte 00111100b	

	byte 0,0,0,0,0,0,0,0
	
TestSprite_end:	

TestSpritePalette:	;   FB 		=Fore		Back	
	BYTE 60h,60h,60h,60h,60h,60h,60h,60h		;Line 1=DarkRed
	byte 0,0,0,0,0,0,0,0
TestSpritePalette_end:

VDPInit:
	BYTE 00000010b,128+0	;mode register #0
	BYTE 01100000b,128+1	;mode register #1
	BYTE 00000110b,128+2	;Pattern table name
	BYTE 10011111b,128+3	;colour table (LOW)
	BYTE 00000000b,128+4	;pattern generator table
	BYTE 00110110b,128+5	;sprite attribute table (LOW)
	BYTE 00000111b,128+6	;sprite pattern generator table
	BYTE 11110000b,128+7	;border colour/character colour at text mode
VDPInit_End: