
CursorX    equ userRam+20h



; set VDP RAM start address (low and high byte)
ScrInit:
	mov r11,r10			;Back up Return address
		
		li r0,087F0h	;border colour/character colour at text mode 
		bl @SetVramPos	;Cmd 80 - Reg 7 = F0
		
		li r0,0380h		;Write 40 - 0380 - ram Color addr
		bl @VDP_SetWriteAddress
		
		li r1,0F000h	;Fill Color area FB--
		li r2,32*24		;Bytes of screen
ScrInitFill:	
		movb r1,@8C00h	
		dec r2
		jne ScrInitFill	
		
		li r0,0000h		;Write 0020 - Vram for text chars
		bl @VDP_SetWriteAddress

		clr r0			;Zero Xpos
		movb r0,@CursorX;Xpos
	b *r10				;Return
VDP_SetWriteAddress:		
	ori r0,4000h		;Bit 6=Write
SetVramPos:		
	swpb r0
	movb r0,@8C02h;L	8C02h=Control Port
	swpb r0
	movb r0,@8C02h;H
	b *r11				;Return		
	
PrintString:
	mov r11,r10			;Back up Return address
PrintStringAgain:
		movb *r1+,R0		;Read a Byte
		ci r0,0FF00h		;Is byte 255?
		jeq PrintStringDone
		bl @PrintChar		;Print the Character!
		jmp PrintStringAgain
PrintStringDone:
	b *r10				;Return		
	

PrintCharR3:		
	mov r3,r0			;Move R3 into R0
PrintChar:
	ci r0,06000h		;compare to 96
	jlt PrintCharOk		;<96 then jump
	
	ai r0,0E000h 		;R0=R0-32
PrintCharOk:
	movb r0,@8C00h		;DataPort - put next char on screen
	
	movb @CursorX,r0	;Load Cursor X
	ai r0,00100h			;Inc 1 char
	movb r0,@CursorX	;Save back
		
	B *r11				;Return

	
NewLine:
	movb @CursorX,r0	;Get Xpos
	clr r1				;Space
NewLineb:
	movb r1,@8C00h		;DataPort - Put Char on screen
	ai r0,0100h
	andi r0,1F00h		;Line 32?
	jne NewLineb		;Inc Xpos
	movb r0,@CursorX    ;Save New XPos
	b *r11				;Return
	
	